// CFilter.java

package jipe;

import java.io.*;


/** FileFilter class to display .c, .cpp, .h and .hpp files only
 * in a FileChooser dialog.
 * 
 */
class CFilter extends SpecialFileFilters
{

    /**      */
    public boolean accept(File f)
    {
        boolean accept = super.accept(f);
        if (!accept)
        {
            String suffix = getSuffix(f);
            if (suffix != null)
                accept = suffix.equals("c");
            else if(suffix != null)
            	accept = suffix.startsWith("cpp");
			else if(suffix != null)
            	accept = suffix.equals("h");
			else if(suffix != null)
            	accept = suffix.startsWith("hpp");
        }
        return accept;
    }
    /** Return the text for this type of filter.
     * 
     */
    public String getDescription()
    {
        return "C Files(*.c *.cpp *.h *.hpp)";
    }
}


